#include "Combo.h"

bool Combo::acquireFromFile(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e5: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string s;
    string *p = new string("");
    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        s = *p;

        add(s);
    }

    delete p;
    return true;
}

bool Combo::altering(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e8: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string empty(EMPTY);
    if( in.getline(c, BUFFER_SIZE) ) {
        string line(c);
        if(firstLine) {
            add(line);
            listing();
            clear(empty);
        }

        loto = checkLine1(line);
        switch(loto) {
        case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
            error = "e9: ADD THE DRAW TO LINE-1 OF WHO.TXT";
            return false;
        case LOTO6:
            error = "e35: LOTO6";
            return false;
        case MINILOTO:
            error = "e36: MINILOTO";
            return false;
        case TOO_FEW_GAPS:
            error = "e10: TOO FEW GAPS";
            return false;
        }

    } else {
        error = "e11(Line-1): in.getline(c, BUFFER_SIZE" + CLOSE_BRACKET;
        return false;
    }

    bool found;
    string *p = new string("");
    Characterizable *lineType = new DateFollowed(*p, NO_SPLITTING);
    int loto, r;
    string combinationName("cmb12-34-56.txt");
    string s("");
    TimeName *ct = new TimeName(COMBINATION, TEXT_FILE);
    ToSeven *n = new ToSeven(combinationName, s);

    produceArrays();
    if(whoText) {
        const string who_text(WHO_TEXT);
        saveName = who_text;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        saveName = wt.temporaryName(SERIAL_NUMBER);
    }

    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        s = *p;

        delete lineType;
        lineType = new DateFollowed(s, NO_SPLITTING);
        r = lineType->dateLine();
        if(r > 0) {
            listing();
            clear(s);
            continue;
        }

        found = searchingItemSequence(s);
        if(found) {
            delete ct;
            ct = new TimeName(COMBINATION, TEXT_FILE);
            combinationName = ct->temporaryName(SERIAL_NUMBER);
            cout << combinationName << endl;

            s = firstNumberTrimmed(s);
            loto = ballCount[sequence];
            switch(loto) {
            case LOTO7:
                delete n;
                n = new ToSeven(combinationName, s);
                result = n->writeFile();
                if(result == FA) {
                    error = n->inquiry();
                    delete n;
                    return false;
                }

                delete n;
                break;
            }

            acquireFromFile(combinationName);
        } else {
            add(s);
        }

    }

    in.close();
    listing();
    openSaveClose(saveName);

    delete ct;
    delete lineType;
    delete p;
    return true;
}

bool Combo::openSaveClose(std::string & fileName) {
    using namespace std;

// Trimming
    string s = buffer->str();
    int size = s.length();
    string c;
    for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
        c = s.substr(i, NEW_LINE_LENGTH);
        if(NEW_LINE == c) {
            continue;
        } else {
            s = s.substr(i);
            break;
        }

    }

// Writing
    ofstream saveFile( fileName.c_str() );
    if( saveFile.fail() ) {
        error = "e1: ofstream saveFile( " + fileName + CLOSE_BRACKET;
        return false;
    }

    saveFile << s;
    saveFile.close();
    return true;
}

bool Combo::searchingItemSequence(std::string & s) {
    using namespace std;

    bool found = false;
    int q;

    for(ITEM::iterator i = item.begin(); i != item.end(); ++i) {
        q = s.find(*i);
        if(q != string::npos) {
            found = true;
            sequence = *i;
            break;
        }

    }

    return found;
}

int Combo::checkLine1(std::string & line) {
    using namespace std;

/*
012345678901234567890123456789012
31 18 15 06 14 25 
31 18 15 06 14 25 -A -776
35 29 12 16 13 28 05 
35 29 12 16 13 28 05 -B -548
04 26 32 29 05 25 15 27 11 
04 26 32 29 05 25 15 27 11 -D -92
*/
    int q;
    string s = line;
    for(int i = 0; i < 6; ++i) {
        q = s.find(GAP);
        if(q != string::npos) {
            q += GAP_SIZE;
            s = s.substr(q);
        } else {
            return TOO_FEW_GAPS;
        }

    }

    int lineLength = line.length();
    if(lineLength == 18) {
        return MINILOTO;
    }

    if( MINUS == line.substr(18, 1) ) {
        return MINILOTO;
    }

    if(lineLength == 21) {
        return LOTO6;
    }

    if( MINUS == line.substr(21, 1) ) {
        return LOTO6;
    }

    if(lineLength == 27) {
        return LOTO7;
    }

    if( MINUS == line.substr(27, 1) ) {
        return LOTO7;
    }

    return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
}

 std::string Combo::firstNumberTrimmed(std::string & l) {
    using namespace std;

    int k = strcspn( l.c_str(), "0123456789");
    string c;
    string line = l.substr(k);
    int lineLength = line.length();

    for(int i = lineLength - 1; i >= 0; --i) {
        c = line.substr(i, 1);
        if(GAP == c) {
            continue;
        } else {
            ++i;
            line = line.substr(0, i);
            break;
        }

    }

    return line;
}

void Combo::produceArrays() { // vector, map
    using namespace std;

    item.push_back(BOX_6TO5); ballCount[BOX_6TO5] = 5;
    item.push_back(BOX_7TO5); ballCount[BOX_7TO5] = 5;
    item.push_back(BOX_8TO5); ballCount[BOX_8TO5] = 5;
    item.push_back(BOX_9TO5); ballCount[BOX_9TO5] = 5;
    item.push_back(BOX_7TO6); ballCount[BOX_7TO6] = 6;
    item.push_back(BOX_8TO6); ballCount[BOX_8TO6] = 6;
    item.push_back(BOX_9TO6); ballCount[BOX_9TO6] = 6;
    item.push_back(BOX_10TO6); ballCount[BOX_10TO6] = 6;
    item.push_back(BOX_8TO7); ballCount[BOX_8TO7] = 7;
    item.push_back(BOX_9TO7); ballCount[BOX_9TO7] = 7;
    item.push_back(BOX_10TO7); ballCount[BOX_10TO7] = 7;
    item.push_back(BOX_11TO7); ballCount[BOX_11TO7] = 7;
    itemCount = 12;
}

