#ifndef COMBO_H
#define COMBO_H

#include <map>
#include <vector>
#include "Characte.h"
#include "TimeName.h"
#include "ToSeven.h"

typedef std::map<std::string, int> BALL_COUNT;
typedef std::vector<std::string> ITEM;

class Combo {
    BALL_COUNT ballCount;
    bool firstLine, serialNumber, whoText;
    const bool NO_SPLITTING, SERIAL_NUMBER;
    const int NEW_LINE_LENGTH;
    const std::string BOX_10TO6, BOX_10TO7, BOX_11TO7, BOX_6TO5, BOX_7TO5, BOX_7TO6, BOX_8TO5, BOX_8TO6, BOX_8TO7, BOX_9TO5, BOX_9TO6, BOX_9TO7, CLOSE_BRACKET, co, EMPTY, GAP, MINUS, NEW_LINE;
    int itemCount, loto, result;
    ITEM item;
    std::string error, COMBINATION, saveName, sequence, whose;
    std::stringstream *buffer;
    std::stringstream *combos;

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    void listing() {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c;
    }

    bool acquireFromFile(std::string & fileName);
    bool openSaveClose(std::string & fileName);
    bool searchingItemSequence(std::string & s);
    int checkLine1(std::string & line);
    std::string firstNumberTrimmed(std::string & l);
    void produceArrays();

public:
    ~Combo() {
        delete buffer;
        delete combos;
    }

    std::string altered() const {
        return saveName;
    }

    std::string inquiry() const {
        return error;
    }

    Combo(bool f, bool s, bool w): BOX_10TO6("10to6"), BOX_10TO7("10to7"), BOX_11TO7("11to7"), BOX_6TO5("6to5"), BOX_7TO5("7to5"), BOX_7TO6("7to6"), BOX_8TO5("8to5"), BOX_8TO6("8to6"), BOX_8TO7("8to7"), BOX_9TO5("9to5"), BOX_9TO6("9to6"), BOX_9TO7("9to7"), CLOSE_BRACKET(" )"), co("cmb"), EMPTY(""), GAP(" "), MINUS("-"), NEW_LINE("\n"), NEW_LINE_LENGTH(1), NO_SPLITTING(true), SERIAL_NUMBER(true) {
        firstLine = f;
        serialNumber = s;
        whoText = w;

        buffer = new std::stringstream();
        COMBINATION = co;
        combos = new std::stringstream();
        whose = EMPTY;
    }

    bool altering(std::string & fileName);
};

#endif // COMBO_H
