#include "Mark.h"

Mark::Mark(MarkMemo *mm): B01("01"), B02("02"), B03("03"), B04("04"), B05("05"), B06("06"), B07("07"), B08("08"), B09("09"), B10("10"), B11("11"), B12("12"), B13("13"), B14("14"), B15("15"), B16("16"), B17("17"), B18("18"), B19("19"), B20("20"), B21("21"), B22("22"), B23("23"), B24("24"), B25("25"), B26("26"), B27("27"), B28("28"), B29("29"), B30("30"), B31("31"), B32("32"), B33("33"), B34("34"), B35("35"), B36("36"), B37("37"), B38("38"), B39("39"), B40("40"), B41("41"), B42("42"), B43("43"), BLACK_CIRCLE(""), CLOSE_BRACKET(") "), EMPTY(""), GAP(" "), HYPHEN("-"), KANJI_BEIGE("x"), KANJI_BLUE(""), KANJI_DAI(""), KANJI_GREEN(""), KANJI_KAI(""), KANJI_NAVY(""), KANJI_PURPLE(""), KANJI_RED(""), KANJI_SET("Zbg"), KANJI_YELLOW(""), L01112131("@ 01112131"), L102030("@ 102030"), M01("-A"), M02("-B"), M03("-C"), M04("-D"), M05("-E"), M06("-F"), M07("-G"), M08("-H"), M09("-I"), M10("-J"), MINUS("-"), PARENTHESIS("("), SERIAL_NUMBER(true), WHITE_CIRCLE("") {
    for(int i = 0; i <= LOTO_6_COUNT; ++i) {
        b[i] = NULL;
    }

    for(int place = 0; place < LOTO_7; place += 1 ) {
        mb[0][place] = NULL;
        mb[1][place] = NULL;
    }

    ball[0] = EMPTY;
    ball[1] = B01; ball[2] = B02; ball[3] = B03; ball[4] = B04; ball[5] = B05; ball[6] = B06; ball[7] = B07; ball[8] = B08; ball[9] = B09; ball[10] = B10;
    ball[11] = B11; ball[12] = B12; ball[13] = B13; ball[14] = B14; ball[15] = B15; ball[16] = B16; ball[17] = B17; ball[18] = B18; ball[19] = B19; ball[20] = B20;
    ball[21] = B21; ball[22] = B22; ball[23] = B23; ball[24] = B24; ball[25] = B25; ball[26] = B26; ball[27] = B27; ball[28] = B28; ball[29] = B29; ball[30] = B30;
    ball[31] = B31; ball[32] = B32; ball[33] = B33; ball[34] = B34; ball[35] = B35; ball[36] = B36; ball[37] = B37; ball[38] = B38; ball[39] = B39; ball[40] = B40;
    ball[41] = B41; ball[42] = B42; ball[43] = B43;

// Mapping set numbers to set names
    BALL_SET[0] = M01; BALL_SET[1] = M02; BALL_SET[2] = M03; BALL_SET[3] = M04; BALL_SET[4] = M05; BALL_SET[5] = M06; BALL_SET[6] = M07; BALL_SET[7] = M08; BALL_SET[8] = M09; BALL_SET[9] = M10;

// Mapping set names to set numbers
    for(int i = 0; i < BALL_SET_COUNT; ++i) {
        setNameNumber[ BALL_SET[i] ] = i;
    }

    beige_number = mm->ballNumber(BEIGE);
    blue_number = mm->ballNumber(BLUE);
    firstLine = mm->firstLine();
    green_number = mm->ballNumber(GREEN);
    navy_number = mm->ballNumber(NAVY);
    purple_number = mm->ballNumber(PURPLE);
    red_number = mm->ballNumber(RED);
    yellow_number = mm->ballNumber(YELLOW);
    z_bonus_number = mm->bonus();
    z_missing_number = mm->missing();

    const int Q = BALLS_BONUS * 3;
    std::string ballsBonus = firstLine.substr(0, Q);
    readLabels[0] = ballsBonus;
    readLabels[3] = EMPTY;
    readLabels[5] = EMPTY;
    readLabels[6] = L01112131;
    readLabels[17] = L102030;

    if(z_bonus_number == UNASSIGNED) {
        second = false;
    } else {
        if(z_missing_number == UNASSIGNED) {
            second = false;
        } else {
            second = true;
        }

    }

    if( setting() ) {
        ;
    } else {
        decideWhichSet();
    }

}

bool Mark::createSeeText() {
    using namespace std;

    const bool SERIAL_NUMBER = true;
    string saveName;

    for(int y = 1; y <= 10; ++y) {
        readLabels[ y + 6 ] = label[y];
    }

    TimeName wt(SEE, TEXT_FILE);
    saveName = wt.temporaryName(SERIAL_NUMBER);
    cout << saveName << endl;

    ofstream text( saveName.c_str() );
    if( text.fail() ) {
        return false;
    }

    for(int i = 0; i < LABEL_COUNT; ++i) {
        text << readLabels[i] << endl;
    }

    return true;
}

int Mark::checkLine1(std::string & line) {
    using namespace std;

/*
012345678901234567890123456789012
31 18 15 06 14 25 
31 18 15 06 14 25 -A -776
35 29 12 16 13 28 05 
35 29 12 16 13 28 05 -B -548
04 26 32 29 05 25 15 27 11 
04 26 32 29 05 25 15 27 11 -D -92
*/
    int q;
    string s = line;
    for(int i = 0; i < 6; ++i) {
        q = s.find(GAP);
        if(q != string::npos) {
            q += GAP_SIZE;
            s = s.substr(q);
        } else {
            return TOO_FEW_GAPS;
        }

    }

    int lineLength = line.length();
    if(lineLength == 18) {
        return MINILOTO;
    }

    if( MINUS == line.substr(18, 1) ) {
        return MINILOTO;
    }

    if(lineLength == 21) {
        return LOTO6;
    }

    if( MINUS == line.substr(21, 1) ) {
        return LOTO6;
    }

    if(lineLength == 27) {
        return LOTO7;
    }

    if( MINUS == line.substr(27, 1) ) {
        return LOTO7;
    }

    return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
}

std::string Mark::itemCaption(std::string & s, std::string & bonus, int which, int place) {
    using namespace std;

    const int Q = place * 3;
    string tail = s.substr(Q);
    string missing = tail.substr(0, 2);
    string i = missing + "-" + bonus;

    mb[which][place] = new MissingBonus(bonus, missing);
    return i;
}

std::string Mark::kanjiColors(std::string & line) {
    using namespace std;

    BallColorSet *bcs = new BallColorSet();
    int ball_set, c;
    Dividing d(line);
    const int FIELD_COUNT = d.fieldCount();
    string field[ PLACE_COUNT + 1 ];

    for(int i = 0; i < FIELD_COUNT; ++i) {
        field[i] = d.a(i);
        if( field[i].length() == 0 ) {
            break;
        }

    }

    string FIELD_9 = field[9];
    string FIELD_10 = field[10];
    stringstream os;

    ball_set = setNameNumber[FIELD_9];

    string ascii_set = FIELD_9.substr(1);
    const string A_J_KANJI_SET = ascii_set + KANJI_SET;
    readLabels[2] = A_J_KANJI_SET;

    string draw_number = FIELD_10.substr(1);
    enum BALL_SET set;
    for(int i = 0; i < BALLS_BONUS; ++i) {
        set = (enum BALL_SET)ball_set;
        c = bcs->ballColor(field[i], set);
        switch(c) {
        case RED:
            os << KANJI_RED << GAP;
            break;
        case YELLOW:
            os << KANJI_YELLOW << GAP;
            break;
        case BEIGE:
            os << KANJI_BEIGE << GAP;
            break;
        case GREEN:
            os << KANJI_GREEN << GAP;
            break;
        case BLUE:
            os << KANJI_BLUE << GAP;
            break;
        case NAVY:
            os << KANJI_NAVY << GAP;
            break;
        case PURPLE:
            os << KANJI_PURPLE << GAP;
            break;
        default:
            break;
        }

    }

    string kanji_colors = os.str();
    readLabels[1] = kanji_colors;

    delete bcs;
    return draw_number;
}

std::string Mark::smallerBigger(std::string & pair) {
    using namespace std;

    int q;
    q = pair.find(GAP);
    string first = pair.substr(0, q);
    q += GAP_SIZE;
    string second = pair.substr(q);

    q = second.find(GAP);
    if(q != string::npos) {
        second = second.substr(0, q);
    }

    int n1 = integerFromString(first);
    int n2 = integerFromString(second);

    stringstream os;
    if(n1 < n2) {
        os << first << GAP << second;
    } else {
        os << second << GAP << first;
    }

    string s = os.str();
    return s;
}

void Mark::add(int b, int c) {
    BallColorSet *bcs = new BallColorSet();
    std::string s = bcs->ballSetList(b, c); // list of ball sets
    buffer << s;
    delete bcs;
}

void Mark::announcement(std::string & draw_number, std::string & s) {
    using namespace std;

    int q;
    const int Q = LOTO_7 * 3;
    string head = s.substr(0, Q);
    string tail = s.substr(Q);
    string smaller_bigger = smallerBigger(tail);

    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        q = head.find(ball[i]);
        if(q != string::npos) {
            check[i] = true;
        } else {
            check[i] = false;
        }

    }

    stringstream os;
    os << KANJI_DAI << draw_number << KANJI_KAI << GAP;
    for(int i = 1; i <= LOTO_6_COUNT; ++i) {
        if(check[i]) {
            os << ball[i] << GAP;
        }

    }

    os << PARENTHESIS << smaller_bigger << CLOSE_BRACKET;
    string sorted = os.str();
    readLabels[4] = sorted;
}

void Mark::arrayBallXY() {
    using namespace std;

    bool found;
    int width = 4;
    string s;
    string head[11];
    string tail[8];
    stringstream *os = new stringstream();

    head[0] = "";
    head[1] = "01";
    head[2] = "02";
    head[3] = "03";
    head[4] = "04";
    head[5] = "05";
    head[6] = "06";
    head[7] = "07";
    head[8] = "08";
    head[9] = "09";
    head[10] = "10";

    tail[0] = "";
    tail[1] = "31";
    tail[2] = "32";
    tail[3] = "33";
    tail[4] = "34";
    tail[5] = "35";
    tail[6] = "36";
    tail[7] = "37";

    b[0] = new BallXY(ball[0], 0, 0, check[0]);
    b[1] = new BallXY(ball[1], 1, 1, check[1]);
    b[2] = new BallXY(ball[2], 1, 2, check[2]);
    b[3] = new BallXY(ball[3], 1, 3, check[3]);
    b[4] = new BallXY(ball[4], 1, 4, check[4]);
    b[5] = new BallXY(ball[5], 1, 5, check[5]);
    b[6] = new BallXY(ball[6], 1, 6, check[6]);
    b[7] = new BallXY(ball[7], 1, 7, check[7]);
    b[8] = new BallXY(ball[8], 1, 8, check[8]);
    b[9] = new BallXY(ball[9], 1, 9, check[9]);
    b[10] = new BallXY(ball[10], 1, 10, check[10]);
    b[11] = new BallXY(ball[11], 2, 1, check[11]);
    b[12] = new BallXY(ball[12], 2, 2, check[12]);
    b[13] = new BallXY(ball[13], 2, 3, check[13]);
    b[14] = new BallXY(ball[14], 2, 4, check[14]);
    b[15] = new BallXY(ball[15], 2, 5, check[15]);
    b[16] = new BallXY(ball[16], 2, 6, check[16]);
    b[17] = new BallXY(ball[17], 2, 7, check[17]);
    b[18] = new BallXY(ball[18], 2, 8, check[18]);
    b[19] = new BallXY(ball[19], 2, 9, check[19]);
    b[20] = new BallXY(ball[20], 2, 10, check[20]);
    b[21] = new BallXY(ball[21], 3, 1, check[21]);
    b[22] = new BallXY(ball[22], 3, 2, check[22]);
    b[23] = new BallXY(ball[23], 3, 3, check[23]);
    b[24] = new BallXY(ball[24], 3, 4, check[24]);
    b[25] = new BallXY(ball[25], 3, 5, check[25]);
    b[26] = new BallXY(ball[26], 3, 6, check[26]);
    b[27] = new BallXY(ball[27], 3, 7, check[27]);
    b[28] = new BallXY(ball[28], 3, 8, check[28]);
    b[29] = new BallXY(ball[29], 3, 9, check[29]);
    b[30] = new BallXY(ball[30], 3, 10, check[30]);
    b[31] = new BallXY(ball[31], 4, 1, check[31]);
    b[32] = new BallXY(ball[32], 4, 2, check[32]);
    b[33] = new BallXY(ball[33], 4, 3, check[33]);
    b[34] = new BallXY(ball[34], 4, 4, check[34]);
    b[35] = new BallXY(ball[35], 4, 5, check[35]);
    b[36] = new BallXY(ball[36], 4, 6, check[36]);
    b[37] = new BallXY(ball[37], 4, 7, check[37]);
    b[38] = new BallXY(ball[38], 4, 8, check[38]);
    b[39] = new BallXY(ball[39], 4, 9, check[39]);
    b[40] = new BallXY(ball[40], 4, 10, check[40]);
    b[41] = new BallXY(ball[41], 5, 1, check[41]);
    b[42] = new BallXY(ball[42], 5, 2, check[42]);
    b[43] = new BallXY(ball[43], 5, 3, check[43]);

    label[0] = EMPTY;
    label[1] = EMPTY;
    label[2] = EMPTY;
    label[3] = EMPTY;
    label[4] = EMPTY;
    label[5] = EMPTY;
    label[6] = EMPTY;
    label[7] = EMPTY;
    label[8] = EMPTY;
    label[9] = EMPTY;
    label[10] = EMPTY;

    for(int y = 1; y <= 10; ++y) {
        delete os;
        os = new stringstream();

        if(y > 7) { // 38, 39, 40
            width = 3;
        }

        for(int x = 1; x <= width; ++x) {
            found = false;

// Checking if a black circle appears at (x, y)
            for(int i = 1; i <= LOTO_6_COUNT; ++i) {
                if( x == b[i]->ballX() ) {
                    if( y == b[i]->ballY() ) {
                        if( b[i]->black() ) {
                            found = true;
                        }

                    }

                }

            }

            if(found) {
                *os << BLACK_CIRCLE;
            } else {
                *os << WHITE_CIRCLE;
            }

        }

        s = os->str();
        if(width == 3) {
            label[y] = head[y] + s;
        } else {
            label[y] = head[y] + s + tail[y];
        }

    }

    for(int i = 0; i <= LOTO_6_COUNT; ++i) {
        delete b[i];
        b[i] = NULL;
    }

    delete os;
}

void Mark::decideWhichSet() {
    using namespace std;

    if(beige_number != UNASSIGNED) {
        add(beige_number, BEIGE);
    }

    if(blue_number != UNASSIGNED) {
        add(blue_number, BLUE);
    }

    if(green_number != UNASSIGNED) {
        add(green_number, GREEN);
    }

    if(navy_number != UNASSIGNED) {
        add(navy_number, NAVY);
    }

    if(purple_number != UNASSIGNED) {
        add(purple_number, PURPLE);
    }

    if(red_number != UNASSIGNED) {
        add(red_number, RED);
    }

    if(yellow_number != UNASSIGNED) {
        add(yellow_number, YELLOW);
    }

    std::string list_of_ball_sets = buffer.str();
    if( list_of_ball_sets.length() > 0 ) {
        cout << list_of_ball_sets << endl;
    }

}

bool Mark::setting() {
    using namespace std;

    int loto = checkLine1(firstLine);
    switch(loto) {
    case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
        error = "e39: ADD THE DRAW TO LINE-1 OF WHO.TXT";
        return false;
    case LOTO6:
        error = "e40: LOTO6";
        return false;
    case MINILOTO:
        error = "e41: MINILOTO";
        return false;
    case TOO_FEW_GAPS:
        error = "e42: TOO FEW GAPS";
        return false;
    }

    int Q = BALLS_BONUS * 3;
    string ballsBonus = firstLine.substr(0, Q);
    readLabels[0] = ballsBonus;

    drawNumber = kanjiColors(firstLine);
    announcement(drawNumber, firstLine);
    arrayBallXY(); // label[]

    if(second) {
        MissingBonus *mb = new MissingBonus(z_bonus_number, z_missing_number);
        cout << mb->hyphenated() << endl;
        missingBonusHandler(mb);
        delete mb;
    } else {
        createSeeText();
    }

    decideWhichSet();
    return true;
}

void Mark::missingBonusHandler(MissingBonus *p) {
    using namespace std;

// Replacing a missing ball with a bonus ball
    const int B = p->bonusBallNumber();
    const bool OLD_CHECK = check[B];
    check[B] = true;

    const int M = p->missingBallNumber();
    const bool OLD_MISSINNG = check[M];
    check[M] = false;
    arrayBallXY();
    createSeeText();

// Restoring
    check[B] = OLD_CHECK;
    check[M] = OLD_MISSINNG;
}
