#ifndef MARK_H
#define MARK_H

#pragma warn -8006 // Borland C++ 5.5.1 for Win32
#pragma warn -8012
#pragma warn -8018

#define BALL_SET_ARRAY 3 // ballSet[][][3]
#define BALLS_BONUS 9 // LOTO_7 + 2
#define BUFFER_SIZE 2048
#define COLOR_COUNT 7
#define GAP_SIZE 1
#define LABEL_COUNT 18
#define LOTO_6_COUNT 43
#define LOTO_7 7
#define PLACE_COUNT 11 // BALLS_BONUS < PLACE_COUNT < FIELD_COUNT
#define SEE "see"
#define SEE_TEXT "see.txt"
#define SMALL_BUFFER_SIZE 64
#define TEXT_FILE ".txt"
#define UNASSIGNED -1
#define WHO_TEXT "who.txt"
#include <map>
#include "Characte.h"
#include "Dividing.h"
#include "MarkMemo.h"
#include "TimeName.h"

enum BALL_COLOR {RED, YELLOW, BEIGE, GREEN, BLUE, NAVY, PURPLE, BALL_COLOR_COUNT};
enum BALL_SET {A_SET, B_SET, C_SET, D_SET, E_SET, F_SET, G_SET, H_SET, I_SET, J_SET, BALL_SET_COUNT};

typedef std::map<std::string, int> NAME_NUMBER;

class BallColorSet {
    bool reality[ LOTO_6_COUNT + 1 ][BALL_COLOR_COUNT][BALL_SET_COUNT];
    const std::string A_J, B01, B02, B03, B04, B05, B06, B07, B08, B09, B10, B11, B12, B13, B14, B15, B16, B17, B18, B19, B20, B21, B22, B23, B24, B25, B26, B27, B28, B29, B30, B31, B32, B33, B34, B35, B36, B37, B38, B39, B40, B41, B42, B43, EMPTY, GAP, SLASH_GAP;
    int ball_color[ LOTO_6_COUNT + 1 ][BALL_SET_COUNT];
    int ballSet[ LOTO_6_COUNT + 1 ][BALL_COLOR_COUNT][BALL_SET_ARRAY];
    NAME_NUMBER ballNameNumber;
    std::string ball[ LOTO_6_COUNT + 1 ];

    void addingToBallSetArray(int b, int c, int s);
    void setting();

public:
    ~BallColorSet(){}

    BallColorSet();
    int ballColor(std::string & c, int s);
    std::string ballSetList(int b, int c);
};

class BallXY {
    bool black_circle;
    int circle_x, circle_y;
    std::string ball_name;

public:
    ~BallXY(){}

    bool black() const {
        return black_circle;
    }

    int ballX() const {
        return circle_x;
    }

    int ballY() const {
        return circle_y;
    }

    std::string ballName() const {
        return ball_name;
    }

    BallXY(std::string & a, int x, int y, bool b) {
        ball_name = a;
        black_circle = b;
        circle_x = x;
        circle_y = y;
    }

};

class MissingBonus {
    int b, m;
    const std::string HYPHEN;
    std::string bonus, missing, missingBonus;

public:
    ~MissingBonus(){}

    int bonusBallNumber() const {
        return b;
    }

    int missingBallNumber() const {
        return m;
    }

    std::string bonusBallName() const {
        return bonus;
    }

    std::string missingBallName() const {
        return missing;
    }

    std::string hyphenated() const {
        return missingBonus;
    }

    MissingBonus(int bo, int mi);
    MissingBonus(MissingBonus *mb);
    MissingBonus(std::string & bo, std::string & mi);
};

class Mark {
    const bool SERIAL_NUMBER;

    BallXY *b[ LOTO_6_COUNT + 1 ];
    bool second;
    bool bonus[ LOTO_6_COUNT + 1 ];
    bool check[ LOTO_6_COUNT + 1 ];
    const std::string B01, B02, B03, B04, B05, B06, B07, B08, B09, B10, B11, B12, B13, B14, B15, B16, B17, B18, B19, B20, B21, B22, B23, B24, B25, B26, B27, B28, B29, B30, B31, B32, B33, B34, B35, B36, B37, B38, B39, B40, B41, B42, B43, BLACK_CIRCLE, CLOSE_BRACKET, EMPTY, GAP, HYPHEN, KANJI_BEIGE, KANJI_BLUE, KANJI_DAI, KANJI_GREEN, KANJI_KAI, KANJI_NAVY, KANJI_PURPLE, KANJI_RED, KANJI_SET, KANJI_YELLOW, L01112131, L102030, M01, M02, M03, M04, M05, M06, M07, M08, M09, M10, MINUS, PARENTHESIS, WHITE_CIRCLE;
    int beige_number, blue_number, green_number, navy_number, purple_number, red_number, yellow_number, unhandled, z_bonus_number, z_missing_number;
    MissingBonus *mb[LOTO_7][LOTO_7];
    NAME_NUMBER setNameNumber;
    std::string drawNumber, error, firstLine;
    std::string ball[ LOTO_6_COUNT + 1 ];
    std::string BALL_SET[BALL_SET_COUNT];
    std::string label[11];
    std::string readLabels[LABEL_COUNT];
    std::stringstream buffer;

    bool createSeeText();
    bool setting();
    int checkLine1(std::string & line);
    std::string itemCaption(std::string & s, std::string & bonus, int which, int place);
    std::string kanjiColors(std::string & line);
    std::string smallerBigger(std::string & pair);
    void add(int b, int c);
    void announcement(std::string & draw_number, std::string & s);
    void arrayBallXY();
    void decideWhichSet();
    void missingBonusHandler(MissingBonus *p);

public:
    ~Mark(){}
    Mark(MarkMemo *mm);
};

bool readFilesBeforeCreatingWindows(std::string & commandLine);
bool removeTemporaryFiles();
int integerFromString(std::string & data);
int modified_file(const char *file_name);
void createErrorText(std::string & messages);
void guide(bool comments);

#endif // MARK_H
