#include "NewLines.h"

bool NewLines::altering(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e29: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string empty(EMPTY);
    if( in.getline(c, BUFFER_SIZE) ) {
        string line(c);
        if(firstLine) {
            add(line);
            listing();
            clear(empty);
        }

        loto = checkLine1(line);
        switch(loto) {
        case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
            error = "e30: ADD THE DRAW TO LINE-1 OF WHO.TXT";
            return false;
        case LOTO6:
            error = "e37: LOTO6";
            return false;
        case MINILOTO:
            error = "e38: MINILOTO";
            return false;
        case TOO_FEW_GAPS:
            error = "e31: TOO FEW GAPS";
            return false;
        }

    } else {
        error = "e32(Line-1): in.getline(c, BUFFER_SIZE" + CLOSE_BRACKET;
        return false;
    }

    bool found;
    string *p = new string("");
    string new_line(NEW_LINE);
    Characterizable *lineType = new DateFollowed(*p, NO_SPLITTING);
    int r;
    string s;

    readingToProduceArray();
    if(whoText) {
        const string who_text(WHO_TEXT);
        saveName = WHO_TEXT;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        saveName = wt.temporaryName(serialNumber);
    }

    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        s = *p;

        delete lineType;
        lineType = new DateFollowed(s, NO_SPLITTING);
        r = lineType->dateLine();
        if(r > 0) {
            listing(new_line);
            clear(s);
            continue;
        }

        found = searchingItemSequence(s);
        if(found) {
            delete lineType;
            lineType = new MultiLoto(s, sequence, NOT_AXIAL);
        } else {
            delete lineType;
            lineType = new Gaps(s, loto, NOT_AXIAL);
        }

        for(;;) {
            s = lineType->lotoLine();
            if( s.length() == 0 ) {
                break;
            }

            add(s);
        }

    }

    in.close();
    listing(new_line);
    openSaveClose(saveName);

    delete lineType;
    delete p;
    return true;
}

bool NewLines::openSaveClose(std::string & fileName) {
    using namespace std;

// Trimming
    string s = buffer->str();
    int size = s.length();
    string c;
    for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
        c = s.substr(i, NEW_LINE_LENGTH);
        if(NEW_LINE == c) {
            continue;
        } else {
            s = s.substr(i);
            break;
        }

    }

// Writing
    ofstream saveFile( fileName.c_str() );
    if( saveFile.fail() ) {
        error = "e12: ofstream saveFile( " + fileName + CLOSE_BRACKET;
        return false;
    }

    saveFile << s;
    saveFile.close();
    return true;
}

bool NewLines::readingToProduceArray() {
    using namespace std;

// Reading list_of_items to produce an array
    ifstream in( list_of_items.c_str() );
    if( in.fail() ) {
        error = "e2: ifstream in( " + list_of_items + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string *p = new string("");
    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);

        if( p->length() > 0 ) {
            item.push_back(*p);
        } else {
            item.push_back(BELL);
        }

    }

    in.close();
    delete p;
    return true;
}

bool NewLines::searchingItemSequence(std::string & s) {
    using namespace std;

    bool found = false;
    int q;

    for(ITEM::iterator i = item.begin(); i != item.end(); ++i) {
        q = s.find(*i);
        if(q != string::npos) {
            found = true;
            sequence = *i;
            break;
        }

    }

    return found;
}

int NewLines::checkLine1(std::string & line) {
    using namespace std;
/*
012345678901234567890123456789012
31 18 15 06 14 25 
31 18 15 06 14 25 -A -776
35 29 12 16 13 28 05 
35 29 12 16 13 28 05 -B -548
04 26 32 29 05 25 15 27 11 
04 26 32 29 05 25 15 27 11 -D -92
*/
    int q;
    string s = line;
    for(int i = 0; i < 6; ++i) {
        q = s.find(GAP);
        if(q != string::npos) {
            q += GAP_SIZE;
            s = s.substr(q);
        } else {
            return TOO_FEW_GAPS;
        }

    }

    int lineLength = line.length();
    if(lineLength == 18) {
        return MINILOTO;
    }

    if( MINUS == line.substr(18, 1) ) {
        return MINILOTO;
    }

    if(lineLength == 21) {
        return LOTO6;
    }

    if( MINUS == line.substr(21, 1) ) {
        return LOTO6;
    }

    if(lineLength == 27) {
        return LOTO7;
    }

    if( MINUS == line.substr(27, 1) ) {
        return LOTO7;
    }

    return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
}

NewLines::NewLines(bool f, bool s, bool w): BELL("\\a"), CLOSE_BRACKET(" )"), EMPTY(""), GAP(" "), MINUS("-"), NEW_LINE("\n"), NEW_LINE_LENGTH(1), NOT_AXIAL(false), NO_SPLITTING(true), SEPARATE_TEXT("separate.txt") {
    using namespace std;

    firstLine = f;
    serialNumber = s;
    whoText = w;

    buffer = new stringstream();
    combos = new stringstream();
    whose = EMPTY;
}
