/*
zoko Version 1.19
Finding Loto-7 winners
Copyright 2017 Sogaya

GCC

*/

#include "zoko.h"

namespace {
    using namespace std;

    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int BALLS = 4;
    const int ERROR_CODE = 1;
    const int NEW_LINE_LENGTH = 1;
    const string BEIGE_TERM("-be");
    const string BLUE_TERM("-bl");
    const string BONUS("-b");
    const string BONUS_3("-c3b");
    const string BONUS_6("-c6b");
    const string CLOSE_BRACKET(" )");
    const string COUNT("-c");
    const string CSV("--csv");
    const string DRAFO_CSV("drafo.csv");
    const string EMPTY("");
    const string EXCLUDE("-e");
    const string EXCLUDE_TEXT("exclude.txt");
    const string GREEN_TERM("-gr");
    const string MARK("-m");
    const string NAVY_BLUE_TERM("-na");
    const string NEW_LINE("\n");
    const string NO_EDITING("-e-");
    const string NO_PREEDITING("-p-");
    const string NO_REMOVING("-r-");
    const string NO_SPLITTING("-s-");
    const string OVERWRITE("-o");
    const string PURPLE_TERM("-pu");
    const string QUIT("-q");
    const string RED_TERM("-re");
    const string REMOVE_LINE_1("-1-");
    const string SEPARATE_TEXT("separate.txt");
    const string TABLE("-a");
    const string THREE_LINES_UNITED("-3");
    const string VERSION_COMMENTS("-VC");
    const string VERSION_GUIDE("-V");
    const string YELLOW_TERM("-ye");
    const string Z_MISSING_BONUS("-z");
    const string ZERO("0");

    bool csv, firstLine, noSplitting, preedit, serialNumber, threeLinesUnited, whoText;
    int balls, rowCount;
    std::string error, fileName, FULL_PATH_NAME, list_of_items;

    const string m0(           ""); // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
    const string m1(    "who.txt"); // m[1], fileName
    const string m2("exclude.txt"); // m[2], list_of_items
    const string m3(          "4"); // m[3], balls
    const string m4(          "1"); // m[4], firstLine
    const string m5(          "0"); // m[5], noSplitting
    const string m6(          "1"); // m[6], preedit
    const string m7(       "5000"); // m[7], rowCount
    const string m8(          "1"); // m[8], serialNumber
    const string m9(          "0"); // m[9], whoText
    const string m10(         "0"); // m[10], threeLinesUnited
}

bool removeTemporaryFiles() {
    using namespace std;

    char c[FILE_NAME_SIZE];
    ifstream in(REMOVE_ERROR_TEXT);
    if( in.fail() ) {
        return false;
    }

    while( in.getline(c, FILE_NAME_SIZE) ) {
        if( strcmp(c, SEE_TEXT) ) { // Do not remove SEE_TEXT.
            if( strcmp(c, TABULATE_TEXT) ) { // Do not remove TABULATE_TEXT.
                if( strcmp(c, TRUE_TEXT) ) { // Do not remove TRUE_TEXT.
                    if( strcmp(c, WHO_TEXT) ) { // Do not remove WHO_TEXT.
                        remove(c);
                    }

                }

            }

        }

    }

    return true;
}

bool testDrafoCsv() {
    using namespace std;

    bool result;
    ifstream test( DRAFO_CSV.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( DRAFO_CSV.c_str() );
    file << "&#160;, ," << endl;
    file << "&nbsp;, ," << endl;
    file << "a,A," << endl;
    file << "l,L," << endl;
    file << "p,P," << endl;
    file << "q,Q," << endl;
    file << "\\,, ," << endl;
    file << "., ," << endl;
    file << "      , ," << endl;
    file << "     , ," << endl;
    file << "    , ," << endl;
    file << "   , ," << endl;
    file << "  , ," << endl;
    file << " 1 , 01 ," << endl;
    file << " 2 , 02 ," << endl;
    file << " 3 , 03 ," << endl;
    file << " 4 , 04 ," << endl;
    file << " 5 , 05 ," << endl;
    file << " 6 , 06 ," << endl;
    file << " 7 , 07 ," << endl;
    file << " 8 , 08 ," << endl;
    file << " 9 , 09 ," << endl;
    file << "ALLQP,ALL QP," << endl;
    file << "|,/," << endl;
    return result;
}

bool testExcludeText() {
    using namespace std;

    bool result;
    ifstream test( EXCLUDE_TEXT.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( EXCLUDE_TEXT.c_str() );
    file << "ʂ" << endl; // Shift_JIS
    file << " ID:" << endl;
    return result;
}

bool testSeparateText() {
    using namespace std;

    bool result;
    ifstream test( SEPARATE_TEXT.c_str() );
    if( test.fail() ) {
        result = false;
    } else {
        test.close();
        result = true;
        return result;
    }

    ofstream file( SEPARATE_TEXT.c_str() );
    file << "/" << endl;
    file << "|" << endl;
    return result;
}

int main(int argc, char *argv[]) {
    using namespace std;

    bool countBonus = false;
    bool destroyWhoText= false;
    bool mark = false;
    bool provided[PROVIDED_SIZE];
    bool quit = false;
    bool removeFirst = true;
    int q;
    int beige_number = UNASSIGNED;
    int blue_number = UNASSIGNED;
    int green_number = UNASSIGNED;
    int navy_number = UNASSIGNED;
    int purple_number = UNASSIGNED;
    int red_number = UNASSIGNED;
    int yellow_number = UNASSIGNED;
    int z_bonus_number = UNASSIGNED;
    int z_missing_number = UNASSIGNED;
    Numbered *n = new Numbered("");
    string *p = new string("");
    string argument;
    string manage_text_name(MANAGE_TEXT);
    string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; 
    string who_text(WHO_TEXT);

    csv = false;
    error = EMPTY;
    fileName = who_text;
    firstLine = true;
    balls = BALLS;
    list_of_items = EXCLUDE_TEXT;
    noSplitting = false;
    preedit = true;
    serialNumber = true;
    threeLinesUnited = false;
    whoText = true; // destroyWhoText = false;

    provided[0] = testDrafoCsv();
    provided[1] = testExcludeText();
    provided[2] = testSeparateText();
    for(int i = 0; i < PROVIDED_SIZE; ++i) {
        if(provided[i]) {
            continue;
        } else {
            return ERROR_CODE;
        }

    }

// C:\zoko\manage.txt for example
    string firstPart = currentDirectory(); // OS-specific.h and OS-specific.cpp
    NAMES a = driveDirectoryBase(firstPart);
    string SEPARATOR = a.separator;
    string root = a.name[1];
    if (firstPart == root) { // C:\ for example
        FULL_PATH_NAME = root + manage_text_name;
    } else { // C:\zoko for example
        FULL_PATH_NAME = firstPart + SEPARATOR + manage_text_name;
    }

    ifstream file( FULL_PATH_NAME.c_str() );
    if ( file.fail() ) { // MANAGE_TEXT
// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

        return ERROR_CODE;
    }

// Reading MANAGE_TEXT
    char c[BUFFER_SIZE];
    ifstream in( FULL_PATH_NAME.c_str() );
    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    fileName = m[1];
    list_of_items = m[2];
    balls = integerFromString(m[3]);
    rowCount = integerFromString(m[7]);

    firstLine = (ZERO == m[4]) ? false : true;
    noSplitting = (ZERO == m[5]) ? false : true;
    preedit = (ZERO == m[6]) ? false : true;
    serialNumber = (ZERO == m[8]) ? false : true;
    destroyWhoText = (ZERO == m[9]) ? false : true;
    threeLinesUnited = (ZERO == m[10]) ? false : true;

    const int based_on_m3 = balls;
    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(BONUS_3 == argument) {
            balls = 3;
            countBonus = true;
        } else if(BONUS_6 == argument) {
            balls = 6;
            countBonus = true;
        } else if(CSV == argument) {
            csv = true;
        } else if(EXCLUDE == argument) {
            list_of_items = EXCLUDE_TEXT;
        } else if(MARK == argument) {
            mark = true;
        } else if(NO_EDITING == argument) {
            preedit = false;
        } else if(NO_PREEDITING == argument) {
            preedit = false;
        } else if(NO_REMOVING == argument) {
            removeFirst = false;
        } else if(NO_SPLITTING == argument) {
            noSplitting = true;
        } else if(OVERWRITE == argument) {
            destroyWhoText = true;
        } else if(QUIT == argument) {
            quit = true;
        } else if(REMOVE_LINE_1 == argument) {
            firstLine = false;
        } else if(TABLE == argument) {
            csv = true;
        } else if(THREE_LINES_UNITED == argument) { // The web browser may divide a date line into three lines, which shall be united to form the date line.
            threeLinesUnited = true;
        } else if(VERSION_COMMENTS == argument) {
            guide(WITH_COMMENTS);
            delete n; delete p;
            return 1;

        } else if(VERSION_GUIDE == argument) {
            guide(WITHOUT_COMMENTS);
            delete n; delete p;
            return 1;

        } else {
            if(whoText) {
                fileName = argument;
                whoText = false;
            } else {
                q = argument.find(BEIGE_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    beige_number = n->number();
                    if( n->parameter() == BEIGE_TERM ) {
                        mark = true;
                        continue;
                    }

                    beige_number = UNASSIGNED;
                }

                q = argument.find(BLUE_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    blue_number = n->number();
                    if( n->parameter() == BLUE_TERM ) {
                        mark = true;
                        continue;
                    }

                    blue_number = UNASSIGNED;
                }

                q = argument.find(BONUS);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    balls = n->number();
                    countBonus = true;
                    if( n->parameter() == BONUS ) {
                        continue;
                    }

                    balls = based_on_m3;
                    countBonus = false;
                }

                q = argument.find(COUNT);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    balls = n->number();
                    if( n->parameter() == COUNT ) {
                        continue;
                    }

                    balls = based_on_m3;
                }

                q = argument.find(GREEN_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    green_number = n->number();
                    if( n->parameter() == GREEN_TERM ) {
                        mark = true;
                        continue;
                    }

                    green_number = UNASSIGNED;
                }

                q = argument.find(NAVY_BLUE_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    navy_number = n->number();
                    if( n->parameter() == NAVY_BLUE_TERM ) {
                        mark = true;
                        continue;
                    }

                    navy_number = UNASSIGNED;
                }

                q = argument.find(PURPLE_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    purple_number = n->number();
                    if( n->parameter() == PURPLE_TERM ) {
                        mark = true;
                        continue;
                    }

                    purple_number = UNASSIGNED;
                }

                q = argument.find(RED_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    red_number = n->number();
                    if( n->parameter() == RED_TERM ) {
                        mark = true;
                        continue;
                    }

                    red_number = UNASSIGNED;
                }

                q = argument.find(YELLOW_TERM);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    yellow_number = n->number();
                    if( n->parameter() == YELLOW_TERM ) {
                        mark = true;
                        continue;
                    }

                    yellow_number = UNASSIGNED;
                }

                q = argument.find(Z_MISSING_BONUS);
                if(q != string::npos) {
                    delete n;
                    n = new Numbered(argv[i]);
                    z_bonus_number = n->number();
                    if( n->trimmed_sequence() ) {
                        z_missing_number = n->subnumber();
                        if( n->parameter() == Z_MISSING_BONUS ) {
                            mark = true;
                            continue;
                        }

                    }

                    z_missing_number = UNASSIGNED;
                    z_bonus_number = UNASSIGNED;
                }

                list_of_items = argument;
            }

        }

    }

    if(removeFirst) {
        removeTemporaryFiles();
    }

    if(whoText) {
        ;
    } else {
        whoText = destroyWhoText;
    }

    if(mark) {
// Producing a text (see7654-32-10.txt, for example) which shows marks.
        char buffer[BUFFER_SIZE];
        string LINE_1;
        ifstream in( fileName.c_str() );
        if( in.fail() ) {
            error = "e6: ifstream in( " + who_text + CLOSE_BRACKET;
            delete p; delete n;
            return false;
        }

        if( in.getline(buffer, BUFFER_SIZE) ) {
            delete p;
            p = new string(buffer);
            LINE_1 = *p;
        } else {
            error = "e16: in.getline(buffer, BUFFER_SIZE" + CLOSE_BRACKET;
            delete p; delete n;
            return false;
        }

        in.close();

        MarkMemo *mm = new MarkMemo(LINE_1, beige_number, blue_number, green_number, navy_number, purple_number, red_number, yellow_number, z_bonus_number, z_missing_number);
        Mark *m = new Mark(mm);
        delete m;
        delete mm;
    } else {
        EditCount *ec = new EditCount();
        ec->setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
        if(quit) {
            if(preedit) {
                ec->preediting();
            }

        } else {
// Preediting and counting to find Loto-7 winners
            ec->editCount();
        }

        delete ec;
    }

    createRemoveErrorText();
    return 0;
}

int integerFromString(std::string & data) {
    using namespace std;

    int value;
    stringstream ss(data);
    ss >> value;
    return value;
}

NAMES driveDirectoryBase(std::string & s) {
    using namespace std;

    const string EMPTY = "";
    const string SLASH = "/";
    const string YEN = "\\";
    int firstTrace, trace, w;
    int s_length = s.length();
    string c;

    NAMES part, undivided;
    part.name[0] = EMPTY; part.name[1] = EMPTY; part.name[2] = EMPTY; part.name[3] = EMPTY;
    undivided.name[0] = EMPTY; undivided.name[1] = EMPTY; undivided.name[2] = EMPTY; undivided.name[3] = EMPTY;

    part.name[0] = s; // s.length > 0; in other words, part.name[0].length > undivided.name[0].length

// s is divided into three parts: drive name, directory name, and base name.
    int k = 0;
    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == YEN) {
            part.separator = YEN;
            break;
        } else if(c == SLASH) {
            part.separator = SLASH;
            break;
        }

    }

    if(k == s_length) { // Neither YEN nor SLASH has been found.
        return undivided;
    } else {
        w = k + 1;
        part.name[1] = s.substr(0, w); // C:\ for example
        trace = ++k;
        firstTrace = trace;
    }

    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == part.separator) {
            trace = ++k;
        }

    }

    w = trace - firstTrace;
    part.name[2] = s.substr(firstTrace, w);
    part.name[3] = s.substr(trace); // manage.txt for example
    return part;
}

void createErrorText(std::string & messages) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << messages << endl;
}

void guide(bool comments) {
    using namespace std;

    if(comments) {
        cerr << "zoko Version " << VERSION << " \n" << endl 
            << "zoko -V               # version " << endl 
            << "zoko -VC              # version with comments " << endl 
            << "zoko who.txt -1-      # Remove Line-1. " << endl 
            << "zoko who.txt -3       # Unite three lines to form a date Line. " << endl 
            << "zoko who.txt -a       # Produce CSV files. " << endl 
            << "zoko who.txt -b3      # Write if they match 3 balls and a bonus ball. " << endl 
            << "zoko who.txt -be17    # beige ball-17 " << endl 
            << "zoko who.txt -bl15    # blue ball-15 " << endl 
            << "zoko who.txt -c3b     # Write if they match 3 balls and a bonus ball. " << endl 
            << "zoko who.txt -c4      # Read who.txt and write if they match 4 balls. " << endl 
            << "zoko who.txt -c6b     # Write if they match 6 balls and a bonus ball. " << endl 
            << "zoko who.txt -e exclude.txt # Every nurupo resu is excluded from who.txt " << endl 
            << "zoko who.txt -gr35    # green ball-35 " << endl 
            << "zoko who.txt -m       # Show marking so that thay can match seven balls. " << endl 
            << "zoko who.txt -na34    # navy blue ball-34 " << endl 
            << "zoko who.txt -o       # Overwrite who.txt " << endl 
            << "zoko who.txt -p-      # Do not edit who.txt " << endl 
            << "zoko who.txt -pu28    # purple ball-28 " << endl 
            << "zoko who.txt -q       # Quit before finding. " << endl 
            << "zoko who.txt -r-      # Do not remove temporary files. " << endl 
            << "zoko who.txt -re15    # red ball-15 " << endl 
            << "zoko who.txt -s-      # Do not split date lines. " << endl 
            << "zoko who.txt -ye23    # yellow ball-23 " << endl 
            << "zoko who.txt -z19-27  # Replace ball-19 with bonus ball-27. " << endl;
    } else {
        cerr << "zoko Version " << VERSION << " \n" << endl 
            << "zoko -V               " << endl 
            << "zoko -VC              " << endl 
            << "zoko who.txt -1-      " << endl 
            << "zoko who.txt -3       " << endl 
            << "zoko who.txt -a       " << endl 
            << "zoko who.txt -b3      " << endl 
            << "zoko who.txt -be17    " << endl 
            << "zoko who.txt -bl15    " << endl 
            << "zoko who.txt -c3b     " << endl 
            << "zoko who.txt -c4      " << endl 
            << "zoko who.txt -c6b     " << endl 
            << "zoko who.txt -e exclude.txt " << endl 
            << "zoko who.txt -gr35    " << endl 
            << "zoko who.txt -m       " << endl 
            << "zoko who.txt -na34    " << endl 
            << "zoko who.txt -o       " << endl 
            << "zoko who.txt -p-      " << endl 
            << "zoko who.txt -pu28    " << endl 
            << "zoko who.txt -q       " << endl 
            << "zoko who.txt -r-      " << endl 
            << "zoko who.txt -re15    " << endl 
            << "zoko who.txt -s-      " << endl 
            << "zoko who.txt -ye23    " << endl 
            << "zoko who.txt -z19-27  " << endl;
    }

}
